*** epp.ori	Fri Apr 27 10:14:37 2012
--- epp.erl	Fri Apr 27 10:19:07 2012
***************
*** 243,258 ****
--- 243,273 ----
      [{attribute,La,record,{Record,Fields}}|
       restore_typed_record_fields(Forms)];
  restore_typed_record_fields([Form|Forms]) ->
      [Form|restore_typed_record_fields(Forms)].
  
+ bom_encoding(Name) ->
+     Bin = case file:open(Name, [binary]) of
+         {ok, Fid} ->
+             % BOM for UTF-7 is 16 bytes
+             case file:read(Fid, 16) of
+                 {ok, X} -> X;
+                 _ -> <<>>
+             end;
+         _ -> <<>>
+     end,
+     unicode:bom_to_encoding(Bin).
+ 
  %% server(StarterPid, FileName, Path, PreDefMacros)
  
  server(Pid, Name, Path, Pdm) ->
      process_flag(trap_exit, true),
      %case file:open(Name, [read]) of
+     {Encoding, BOMLen} = bom_encoding(Name),
+     case file:open(Name, [read, {encoding, Encoding}]) of
  	{ok,File} ->
+         file:position(File, BOMLen),
          Location = 1,
  	    init_server(Pid, Name, File, Location, Path, Pdm, false);
  	{error,E} ->
  	    epp_reply(Pid, {error,E})
      end.
